-- name: [CS] Super Paper Villains
-- description: ochunks \n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!



local E_MODEL_OCHUNKS = smlua_model_util_get_id("ochunks_geo")
local E_MODEL_OCHUNKS_STEM = smlua_model_util_get_id("ochunks_stem_geo")

local E_MODEL_MIMI_DEFAULT = smlua_model_util_get_id("mimi_default_geo")
local E_MODEL_MIMI_ADVENTURE = smlua_model_util_get_id("mimi_adventure_geo")
local E_MODEL_MIMI_BANK = smlua_model_util_get_id("mimi_bank_geo")
local E_MODEL_MIMI_BEACH = smlua_model_util_get_id("mimi_beach_geo")
local E_MODEL_MIMI_CHEER = smlua_model_util_get_id("mimi_cheer_geo")
local E_MODEL_MIMI_FORMAL = smlua_model_util_get_id("mimi_formal_geo")
local E_MODEL_MIMI_MAID = smlua_model_util_get_id("mimi_maid_geo")
local E_MODEL_MIMI_POST = smlua_model_util_get_id("mimi_post_geo")
local E_MODEL_MIMI_SAMMER = smlua_model_util_get_id("mimi_sammer_geo")
local E_MODEL_MIMI_SUIT = smlua_model_util_get_id("mimi_suit_geo")

local E_MODEL_CBLECK = smlua_model_util_get_id("bleck_geo")

local TEX_OCHUNKS = get_texture_info("ochunks_icon")
local TEX_MIMI = get_texture_info("mimi_icon")
local TEX_CBLECK = get_texture_info("bleck_icon")

local TEXT_MOD_NAME = "[CS] SUPER PAPER VILLAINS"

local E_MODEL_STAR_1PH = smlua_model_util_get_id("1_pheart_geo")
local TEX_STAR_1PH = get_texture_info("1_pheart")

local E_MODEL_STAR_2PH = smlua_model_util_get_id("2_pheart_geo")
local TEX_STAR_2PH = get_texture_info("2_pheart")

local E_MODEL_STAR_3PH = smlua_model_util_get_id("3_pheart_geo")
local TEX_STAR_3PH = get_texture_info("3_pheart")

local E_MODEL_STAR_4PH = smlua_model_util_get_id("4_pheart_geo")
local TEX_STAR_4PH = get_texture_info("4_pheart")

local E_MODEL_STAR_5PH = smlua_model_util_get_id("5_pheart_geo")
local TEX_STAR_5PH = get_texture_info("5_pheart")

local E_MODEL_STAR_6PH = smlua_model_util_get_id("6_pheart_geo")
local TEX_STAR_6PH = get_texture_info("6_pheart")

local E_MODEL_STAR_7PH = smlua_model_util_get_id("7_pheart_geo")
local TEX_STAR_7PH = get_texture_info("7_pheart")

local E_MODEL_STAR_8PH = smlua_model_util_get_id("8_pheart_geo")
local TEX_STAR_8PH = get_texture_info("8_pheart")

local E_MODEL_STAR_DARKPH = smlua_model_util_get_id("dark_pheart_geo")
local TEX_STAR_DARKPH = get_texture_info("dark_pheart")

local VOICETABLE_OCHUNKS = {
    [CHAR_SOUND_ATTACKED] = 'oc_Attacked.ogg',
    [CHAR_SOUND_COUGHING1] = 'oc_COUGHING1.ogg',
    [CHAR_SOUND_COUGHING2] = 'oc_COUGHING2.ogg',
    [CHAR_SOUND_COUGHING3] = 'oc_COUGHING3.ogg',
    [CHAR_SOUND_DOH] = 'oc_DOH.ogg',
    [CHAR_SOUND_DROWNING] = 'oc_DROWNING.ogg',
    [CHAR_SOUND_DYING] = 'oc_DYING.ogg',
    [CHAR_SOUND_EEUH] = 'oc_EEUH.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'oc_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_HAHA] = 'oc_HAHA.ogg',
    [CHAR_SOUND_HAHA_2] = 'oc_HAHA_2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'oc_HERE_WE_GO.ogg',
    [CHAR_SOUND_HOOHOO] = {'oc_HOOHOO.ogg', 'oc_HOOHOO2.ogg'},
    [CHAR_SOUND_HRMM] = 'oc_HRMM.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'oc_IMA_TIRED.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'oc_MAMA_MIA.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'oc_LETS_A_GO.ogg',
    [CHAR_SOUND_ON_FIRE] = 'oc_ON_FIRE.ogg',
    [CHAR_SOUND_OOOF] = 'oc_OOOF.ogg',
    [CHAR_SOUND_OOOF2] = 'oc_OOOF2.ogg',
    [CHAR_SOUND_PANTING] = 'oc_PANTING.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'oc_PANTING_COLD.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'oc_PUNCH_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'oc_PUNCH_WAH.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'oc_PUNCH_YAH.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'oc_SO_LONGA_BOWSER.ogg',
    [CHAR_SOUND_SNORING1] = 'oc_SNORING1.ogg',
    [CHAR_SOUND_SNORING2] = 'oc_SNORING2.ogg',
    [CHAR_SOUND_SNORING3] = {'oc_SNORING2.ogg', 'oc_SNORING1.ogg', 'oc_SNORING3.ogg'},
    [CHAR_SOUND_TWIRL_BOUNCE] = 'oc_TWIRL_BOUNCE.ogg',
    [CHAR_SOUND_UH] = 'oc_UH.ogg',
    [CHAR_SOUND_UH2] = 'oc_UH2.ogg',
    [CHAR_SOUND_UH2_2] = 'oc_UH2_2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'oc_WAAAOOOW.ogg',
    [CHAR_SOUND_WAH2] = 'oc_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_WHOA] = 'oc_WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 'oc_YAHOO.ogg',
    [CHAR_SOUND_YAWNING] = 'oc_YAWNING.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'oc_YAHOO.ogg', 'oc_YAHOO_WAHA_YIPPEE1.ogg', 'oc_YAHOO_WAHA_YIPPEE2.ogg', 'oc_YAHOO_WAHA_YIPPEE3.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 'oc_YAH_WAH_HOO.ogg', 'oc_YAH_WAH_HOO2.ogg'},
    }


local VOICETABLE_CBLECK = {
    [CHAR_SOUND_ATTACKED] = 'cb_CHAR_SOUND_ATTACKED.ogg',
   -- [CHAR_SOUND_COUGHING1] = 'cb_CHAR_SOUND_COUGHING1.ogg',
   -- [CHAR_SOUND_COUGHING2] = 'cb_CHAR_SOUND_COUGHING2.ogg',
   -- [CHAR_SOUND_COUGHING3] = 'cb_CHAR_SOUND_COUGHING3.ogg',
    [CHAR_SOUND_DOH] = 'cb_CHAR_SOUND_DOH.ogg',
    [CHAR_SOUND_DROWNING] = 'cb_CHAR_SOUND_DROWNING.ogg',
    [CHAR_SOUND_DYING] = 'cb_CHAR_SOUND_DYING.ogg',
    [CHAR_SOUND_EEUH] = 'cb_CHAR_SOUND_EEUH.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'cb_CHAR_SOUND_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_HAHA] = 'cb_CHAR_SOUND_HAHA.ogg',
    [CHAR_SOUND_HAHA_2] = 'cb_CHAR_SOUND_HAHA.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'cb_CHAR_SOUND_HERE_WE_GO.ogg',
    [CHAR_SOUND_HOOHOO] = {'cb_CHAR_SOUND_HOOHOO.ogg'},
    [CHAR_SOUND_HRMM] = 'cb_CHAR_SOUND_HRMM.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'cb_CHAR_SOUND_IMA_TIRED.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'cb_CHAR_SOUND_MAMA_MIA.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'cb_CHAR_SOUND_LETS_A_GO.ogg',
    [CHAR_SOUND_ON_FIRE] = 'cb_CHAR_SOUND_ON_FIRE.ogg',
    [CHAR_SOUND_OOOF] = 'cb_CHAR_SOUND_OOOF.ogg',
    [CHAR_SOUND_OOOF2] = 'cb_CHAR_SOUND_OOOF2.ogg',
    [CHAR_SOUND_PANTING] = 'cb_CHAR_SOUND_PANTING.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'cb_CHAR_SOUND_PANTING_COLD.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'cb_CHAR_SOUND_PUNCH_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'cb_CHAR_SOUND_PUNCH_WAH.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'cb_CHAR_SOUND_PUNCH_YAH.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'cb_CHAR_SOUND_SO_LONGA_BOWSER.ogg',
   -- [CHAR_SOUND_SNORING1] = 'cb_SNORING1.ogg',
   -- [CHAR_SOUND_SNORING2] = 'cb_SNORING2.ogg',
    [CHAR_SOUND_SNORING3] = {nil, nil, 'cb_CHAR_SOUND_SNORING3.ogg'},
    [CHAR_SOUND_TWIRL_BOUNCE] = 'cb_CHAR_SOUND_TWIRL_BOUNCE.ogg',
    [CHAR_SOUND_UH] = 'cb_CHAR_SOUND_UH.ogg',
    [CHAR_SOUND_UH2] = 'cb_CHAR_SOUND_UH2.ogg',
    [CHAR_SOUND_UH2_2] = 'cb_CHAR_SOUND_UH2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'cb_CHAR_SOUND_WAAAOOOW.ogg',
    [CHAR_SOUND_WAH2] = 'cb_CHAR_SOUND_YAH_WAH_HOO2.ogg',
    [CHAR_SOUND_WHOA] = 'cb_CHAR_SOUND_WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 'cb_CHAR_SOUND_YAHOO.ogg',
    [CHAR_SOUND_YAWNING] = 'cb_CHAR_SOUND_YAWNING.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'cb_CHAR_SOUND_YAHOO_WAHA_YIPPEE1.ogg', 'cb_CHAR_SOUND_YAHOO_WAHA_YIPPEE2.ogg', 'cb_CHAR_SOUND_YAHOO_WAHA_YIPPEE3.ogg', 'cb_CHAR_SOUND_YAHOO.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 'cb_CHAR_SOUND_YAH_WAH_HOO1.ogg', 'cb_CHAR_SOUND_YAH_WAH_HOO2.ogg', 'cb_CHAR_SOUND_YAH_WAH_HOO3.ogg'},
}

local VOICETABLE_MIMI = {
    [CHAR_SOUND_ATTACKED] = 'mimi_CHAR_SOUND_ATTACKED.ogg',
    [CHAR_SOUND_COUGHING1] = 'mimi_CHAR_SOUND_COUGHING1.ogg',
    [CHAR_SOUND_COUGHING2] = 'mimi_CHAR_SOUND_COUGHING2.ogg',
    [CHAR_SOUND_COUGHING3] = 'mimi_CHAR_SOUND_COUGHING3.ogg',
    [CHAR_SOUND_DOH] = 'mimi_CHAR_SOUND_DOH.ogg',
    [CHAR_SOUND_DROWNING] = 'mimi_CHAR_SOUND_DROWNING.ogg',
    [CHAR_SOUND_DYING] = 'mimi_CHAR_SOUND_DYING.ogg',
    [CHAR_SOUND_EEUH] = 'mimi_CHAR_SOUND_EEUH.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'mimi_CHAR_SOUND_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_HAHA] = 'mimi_CHAR_SOUND_HAHA.ogg',
    [CHAR_SOUND_HAHA_2] = 'mimi_CHAR_SOUND_HAHA_2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'mimi_CHAR_SOUND_HERE_WE_GO.ogg',
    [CHAR_SOUND_HOOHOO] = 'mimi_CHAR_SOUND_HOOHOO.ogg',
    [CHAR_SOUND_HRMM] = 'mimi_CHAR_SOUND_HRMM.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'mimi_CHAR_SOUND_IMA_TIRED.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'mimi_CHAR_SOUND_MAMA_MIA.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'mimi_CHAR_SOUND_LETS_A_GO.ogg',
    [CHAR_SOUND_ON_FIRE] = 'mimi_CHAR_SOUND_ON_FIRE.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'mimi_CHAR_SOUND_OKEY_DOKEY.ogg',    
    [CHAR_SOUND_OOOF] = 'mimi_CHAR_SOUND_OOOF.ogg',
    [CHAR_SOUND_OOOF2] = 'mimi_CHAR_SOUND_OOOF2.ogg',
    [CHAR_SOUND_PANTING] = 'mimi_CHAR_SOUND_PANTING.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'mimi_CHAR_SOUND_PANTING_COLD.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'mimi_CHAR_SOUND_PUNCH_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'mimi_CHAR_SOUND_PUNCH_WAH.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'mimi_CHAR_SOUND_PUNCH_YAH.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'mimi_CHAR_SOUND_SO_LONGA_BOWSER.ogg',
    [CHAR_SOUND_SNORING1] = 'mimi_CHAR_SOUND_SNORING1.ogg',
    [CHAR_SOUND_SNORING2] = 'mimi_CHAR_SOUND_SNORING2.ogg',
    [CHAR_SOUND_SNORING3] = {'mimi_CHAR_SOUND_SNORING1.ogg', 'mimi_CHAR_SOUND_SNORING2.ogg', 'mimi_CHAR_SOUND_SNORING3.ogg'},
    [CHAR_SOUND_TWIRL_BOUNCE] = 'mimi_CHAR_SOUND_TWIRL_BOUNCE.ogg',
    [CHAR_SOUND_UH] = 'mimi_CHAR_SOUND_UH.ogg',
    [CHAR_SOUND_UH2] = 'mimi_CHAR_SOUND_UH2.ogg',
    [CHAR_SOUND_UH2_2] = 'mimi_CHAR_SOUND_UH2_2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'mimi_CHAR_SOUND_WAAAOOOW.ogg',
    [CHAR_SOUND_WAH2] = 'mimi_CHAR_SOUND_WAH2.ogg',
    [CHAR_SOUND_WHOA] = 'mimi_CHAR_SOUND_WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 'mimi_CHAR_SOUND_YAHOO.ogg',
    [CHAR_SOUND_YAWNING] = 'mimi_CHAR_SOUND_YAWNING.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'mimi_CHAR_SOUND_YAHOO_triple.ogg', 'mimi_CHAR_SOUND_WAHA_triple.ogg', 'mimi_CHAR_SOUND_YIPPEE_triple.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 'mimi_CHAR_SOUND_YAH.ogg', 'mimi_CHAR_SOUND_WAH.ogg', 'mimi_CHAR_SOUND_HOO.ogg'},
}


local capOCHUNKS = {
    normal = smlua_model_util_get_id("ochunks_cap_geo"),
    wing = smlua_model_util_get_id("ochunks_wing_cap_geo"),
    metal = smlua_model_util_get_id("ochunks_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("ochunks_metal_wing_cap_geo")
}

local capMIMI = {
    normal = smlua_model_util_get_id("mimi_cap_geo"),
    wing = smlua_model_util_get_id("mimi_wing_cap_geo"),
    metal = smlua_model_util_get_id("mimi_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("mimi_metal_wing_cap_geo")
}

local capCBLECK = {
    normal = smlua_model_util_get_id("blecks_cap_geo"),
    wing = smlua_model_util_get_id("blecks_wing_cap_geo"),
    metal = smlua_model_util_get_id("blecks_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("blecks_metal_wing_cap_geo")
}

local PALETTE_OCHUNKS = {
    [SHIRT] = "DE1A0C",
    [SHOES] = "1A0901",
    [HAIR] = "A7530A",
    [CAP] = "CCB334",
    [PANTS] = "98795C",
    [GLOVES] = "C0CDCF",
    [SKIN] = "DFCDA7",
    [EMBLEM] = "ffffff",
}

local PALETTE_OCHUNKS_STEM = {
    [SHIRT] = "DE1A0C",
    [SHOES] = "1A0901",
    [HAIR] = "A7530A",
    [CAP] = "CCB334",
    [PANTS] = "98795C",
    [GLOVES] = "C0CDCF",
    [SKIN] = "DFCDA7",
    [EMBLEM] = "9DFF63",
}

local PALETTE_MIMI_DEFAULT = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "ffffff",
    [CAP] = "E70818",
    [PANTS] = "FFDF08",
    [GLOVES] = "FFFFFF",
    [SKIN] = "ffffff",
    [EMBLEM] = "ffffff",
}

local PALETTE_MIMI_POST = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "ffffff",
    [CAP] = "8C96D6",
    [PANTS] = "944DBD",
    [GLOVES] = "FFFFD6",
    [SKIN] = "ffffff",
    [EMBLEM] = "ffffff",
}

local PALETTE_MIMI_BEACH = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "AD6929",
    [CAP] = "8C96D6",
    [PANTS] = "FF0031",
    [GLOVES] = "FFFFFF",
    [SKIN] = "ffffff",
    [EMBLEM] = "ffffff",
}

local PALETTE_MIMI_BANK = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "FFFFFF",
    [CAP] = "E70818",
    [PANTS] = "084994",
    [GLOVES] = "FFFFFF",
    [SKIN] = "ffffff",
    [EMBLEM] = "ffffff",
}

local PALETTE_MIMI_SAMMER = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "EF7100",
    [CAP] = "CE1431",
    [PANTS] = "FF0031",
    [GLOVES] = "FFFFEF",
    [SKIN] = "EFC300",
    [EMBLEM] = "F75D42",
}

local PALETTE_MIMI_FORMAL = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "EF7100",
    [CAP] = "CE1431",
    [PANTS] = "FF8AA5",
    [GLOVES] = "FFC3D6",
    [SKIN] = "FFFBAD",
    [EMBLEM] = "ffffff",
}

local PALETTE_MIMI_ADVENTURE = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "AD8218",
    [CAP] = "AD3418",
    [PANTS] = "315910",
    [GLOVES] = "FFFFFF",
    [SKIN] = "FFFBAD",
    [EMBLEM] = "ffffff",
}

local PALETTE_MIMI_SUIT = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "AD8218",
    [CAP] = "FF00E7",
    [PANTS] = "08B2FF",
    [GLOVES] = "FFFFFF",
    [SKIN] = "FFFBAD",
    [EMBLEM] = "ffffff",
}
local PALETTE_MIMI_MAID = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "FFFFFF",
    [CAP] = "FFFFFF",
    [PANTS] = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SKIN] = "FFFFFF",
    [EMBLEM] = "ffffff",
}

local PALETTE_MIMI_CHEER = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "FFFFFF",
    [CAP] = "E70818",
    [PANTS] = "FF7900",
    [GLOVES] = "FFFFFF",
    [SKIN] = "FFFFFF",
    [EMBLEM] = "ffffff",
}

local PALETTE_CBLECK = {
    [SHIRT] = "D42B08",
    [SHOES] = "732121",
    [HAIR] = "3C3C3C",
    [CAP] = "FF2C50",
    [PANTS] = "2844BD",
    [GLOVES] = "C0CDCF",
    [SKIN] = "E3DCCC",
    [EMBLEM] = "D3B954",
}

--[[
local PM_OCHUNKS= {
    label = {
        left = get_texture_info("ochunks_pm1"),
        right = get_texture_info("ochunks_pm2"),
    },
    pie = { 
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),
        
    }
}
]]

cbleckanims = {
    [CHAR_ANIM_RUNNING] = 'cbleck_running',
    [CHAR_ANIM_TURNING_PART1] = 'cbleck_turning_part1',
    [CHAR_ANIM_TURNING_PART2] = 'cbleck_turning_part2',
    [CHAR_ANIM_SKID_ON_GROUND] = 'cbleck_skid_on_ground',
}


if _G.charSelectExists then
    CT_OCHUNKS = _G.charSelect.character_add("O' Chunks", 
    "It's O'Chunks, the count's hulking, wide-eyed henchman! Word is, the count saved his life. Now he owes him big. Voiced by Mastergun117", "Melzinoff & Mastergun117", {r = 167, g = 83, b = 10}, E_MODEL_OCHUNKS, CT_MARIO, TEX_OCHUNKS)
    CT_MIMI = _G.charSelect.character_add("Mimi", 
    "It's Mimi, the adorable, yet slightly unstable shape-shifter!  Voiced by Lenophie", "Melzinoff & Lenophie", {r = 162, g = 226, b = 41}, E_MODEL_MIMI_DEFAULT, CT_MARIO, TEX_MIMI)

    CT_CBLECK = _G.charSelect.character_add("Count Bleck", 
    "This top-hatted villain is bent on ending the world! Fun fact: he was once known as Count Blumiere. Voiced by LucinaOfStardust", "Melzinoff & LucinaofStardust", {r = 44, g = 80, b = 233}, E_MODEL_CBLECK, CT_MARIO, TEX_CBLECK)


    _G.charSelect.character_add_caps(E_MODEL_OCHUNKS, capOCHUNKS)
    _G.charSelect.character_add_caps(E_MODEL_OCHUNKS_STEM, capOCHUNKS)
    
    _G.charSelect.character_add_caps(E_MODEL_MIMI_DEFAULT, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_MAID, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_ADVENTURE, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_BANK, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_BEACH, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_CHEER, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_FORMAL, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_POST, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_SAMMER, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_SUIT, capMIMI)

    _G.charSelect.character_add_caps(E_MODEL_CBLECK, capCBLECK)



    _G.charSelect.character_add_palette_preset(E_MODEL_OCHUNKS, PALETTE_OCHUNKS)
    _G.charSelect.character_add_palette_preset(E_MODEL_OCHUNKS_STEM, PALETTE_OCHUNKS_STEM)

    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_DEFAULT, PALETTE_MIMI_DEFAULT)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_MAID, PALETTE_MIMI_MAID)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_ADVENTURE, PALETTE_MIMI_ADVENTURE)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_BANK, PALETTE_MIMI_BANK)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_BEACH, PALETTE_MIMI_BEACH)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_CHEER, PALETTE_MIMI_CHEER)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_FORMAL, PALETTE_MIMI_FORMAL)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_POST, PALETTE_MIMI_POST)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_SAMMER, PALETTE_MIMI_SAMMER)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_SUIT, PALETTE_MIMI_SUIT)

    _G.charSelect.character_add_palette_preset(E_MODEL_CBLECK, PALETTE_CBLECK)


    _G.charSelect.character_add_costume(CT_OCHUNKS, "O'Cabbage", nil, nil, nil, E_MODEL_OCHUNKS_STEM, nil, nil, nil, nil)

    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_POST, E_MODEL_STAR_1PH, TEX_STAR_1PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_OCHUNKS, E_MODEL_STAR_1PH, TEX_STAR_1PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_DEFAULT, E_MODEL_STAR_2PH, TEX_STAR_2PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_MAID, E_MODEL_STAR_2PH, TEX_STAR_2PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_BANK, E_MODEL_STAR_2PH, TEX_STAR_2PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_ADVENTURE, E_MODEL_STAR_3PH, TEX_STAR_3PH)
    --_G.charSelect.character_add_celebration_star(E_MODEL_DIMENTIO, E_MODEL_STAR_3PH, TEX_STAR_3PH)
    --_G.charSelect.character_add_celebration_star(E_MODEL_MRL, E_MODEL_STAR_4PH, TEX_STAR_4PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_FORMAL, E_MODEL_STAR_4PH, TEX_STAR_4PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_OCHUNKS_STEM, E_MODEL_STAR_5PH, TEX_STAR_5PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_SUIT, E_MODEL_STAR_5PH, TEX_STAR_5PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_SAMMER, E_MODEL_STAR_6PH, TEX_STAR_6PH)
    --_G.charSelect.character_add_celebration_star(E_MODEL_OCHUNKS, E_MODEL_STAR_7PH, TEX_STAR_7PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_CHEER, E_MODEL_STAR_7PH, TEX_STAR_7PH)
    -- _G.charSelect.character_add_celebration_star(E_MODEL_NASTASIA, E_MODEL_STAR_8PH, TEX_STAR_8PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_BEACH, E_MODEL_STAR_8PH, TEX_STAR_8PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_CBLECK, E_MODEL_STAR_DARKPH, TEX_STAR_DARKPH)


    --_G.charSelect.character_add_health_meter(CT_OCHUNKS, PM_OCHUNKS)

    do
        -- table of skins
        local SKINTABLE_BY = {
            { model = E_MODEL_MIMI_MAID,  name = "Mimi (Maid)"},
            { model = E_MODEL_MIMI_BANK,  name = "Mimi (Bank)"},
            { model = E_MODEL_MIMI_ADVENTURE,  name = "Mimi (Explorer)"},
            { model = E_MODEL_MIMI_FORMAL,  name = "Mimi (Gala)"},
            { model = E_MODEL_MIMI_SUIT,  name = "Mimi (Suit)"},
            { model = E_MODEL_MIMI_SAMMER,  name = "Mimi (Kimono)"},
            { model = E_MODEL_MIMI_CHEER,  name = "Mimi (Cheerleader)"},
            { model = E_MODEL_MIMI_BEACH,  name = "Mimi (Beach)"},
            { model = E_MODEL_MIMI_POST,  name = "Mimi (Soiree)"},
            }
    
        for index, alt in ipairs(SKINTABLE_BY) do
            _G.charSelect.character_add_costume(CT_MIMI, alt.name, nil, nil, nil, alt.model, nil, nil, nil, nil)
        end
    end

    _G.charSelect.character_add_animations(E_MODEL_CBLECK, cbleckanims)

    -- the following must be hooked for each character added
    _G.charSelect.character_add_voice(E_MODEL_OCHUNKS, VOICETABLE_OCHUNKS)
    _G.charSelect.character_add_voice(E_MODEL_OCHUNKS_STEM, VOICETABLE_OCHUNKS)

    _G.charSelect.character_add_voice(E_MODEL_MIMI_DEFAULT, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_MAID, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_BANK, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_ADVENTURE, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_FORMAL, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_SUIT, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_SAMMER, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_CHEER, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_BEACH, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_POST, VOICETABLE_MIMI)

    _G.charSelect.character_add_voice(E_MODEL_CBLECK, VOICETABLE_CBLECK)



    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_OCHUNKS then return _G.charSelect.voice.sound(m, sound) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_MIMI then return _G.charSelect.voice.sound(m, sound) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_CBLECK then return _G.charSelect.voice.sound(m, sound) end

    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_OCHUNKS then return _G.charSelect.voice.snore(m) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_MIMI then return _G.charSelect.voice.snore(m) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_CBLECK then return _G.charSelect.voice.snore(m) end

    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end
